package gg.malloc.defense.commands;

import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.World;

import gg.malloc.defense.engine.GameRunner;

import gg.malloc.defense.Plugin;

public class SetStageCommand implements CommandExecutor {
  Plugin m_plugin;

  public SetStageCommand(Plugin plugin) {
    m_plugin = plugin;
  }

  @Override
  public boolean onCommand(CommandSender sender, Command command, String s, String[] args) {
    World world = m_plugin.getServer().getWorld(args[1]);
    GameRunner runner = m_plugin.getRunnerForWorld(world);
    String stateName = args[0].toLowerCase();
    boolean ret = false;
    GameRunner.Stage decodedStage = null;
    GameRunner.Stage stages[] = GameRunner.Stage.Idle.getDeclaringClass().getEnumConstants();
    for(GameRunner.Stage stage : stages) {
      if (stage.toString().toLowerCase().equals(stateName)) {
        decodedStage = stage;
        break;
      }
    }
    if (decodedStage != null) {
      sender.sendMessage("Requesting transition to " + decodedStage);
      if (!runner.requestTransition(decodedStage)) {
        sender.sendMessage("Could not transition to " + decodedStage);
        return false;
      }
      return true;
    } else {
      sender.sendMessage("Unknown state " + stateName);
      return false;
    }
  }
}
